{\rtf0\ansi{\fonttbl\f0\fmodern Courier;\f1\ftech Symbol;\f2\fmodern Ohlfs;}
\margl40
\margr40
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 //\
//
\i 	
\b FILENAME
\b0 :	
\b\i0 eTAppUI.h \

\b0 //
\i 	
\b SUMMARY
\b0 :	
\b\i0 Header for the eTAppUI class, runs the UI and Workspace Manager
\b0 \
//	
\b\i SUPERCLASS
\b0 :
\i0 	
\b Object:eTAppUI
\b0 \
//	
\b\i PROTOCOLS
\b0 :
\i0 	
\b None
\b0 \
//	
\b\i INTERFACE
\b0 :
\i0 	
\b eText.nib
\b0 \
//	
\b\i AUTHOR
\b0 :		
\b\i0 Rohit Khare
\b0 \
//	
\b\i COPYRIGHT
\b0 :	
\f1\i0 
\f0\b 1993,94 California Institure of Technology, eText Project\

\b0 //\
//	
\b\i Description
\b0\i0 \
//		The eTAppUI class handles all of the detail work associated with\
//			1) communicating with Workspace for file opens\
//			2) responding to user menu commands (info, etc)\
//			3) loading and presenting tools to the user\
//\
//	
\b\i HISTORY\

\b0\i0 //	11/20/94:	
\b Added History Panel UI.
\b0 \
//	10/22/94:	
\b Added Find Panel UI; from MiscFindPanelClass.
\b0 \
//	09/21/94:	
\b Revamped for eText5; removed savePanel, clean interface to eTApp
\b0 \
//	07/06/94:	
\b Added mailDevelopers:
\b0 \
//	05/21/94:	
\b Added savePanel code for multiple-format input.
\b0 \
//	05/05/94:	
\b Added "Accessory" support for future expansion
\b0 \
//	01/13/94:	
\b Extensively rebuilt for eText4 specs.\

\b0 //	09/11/93:
\b 	-registerForDraggedTypes...
\b0 \
//	08/22/93:	
\b Added Tools UI.
\b0 \
//	08/16/93:	
\b Created. Implicitly supports an <eTextServices> protocol
\b0 \
//\
//	
\b Imported Interfaces
\b0 \
//\
	#import "
\b eTextKernel.h
\b0 "\
	#import "
\b InfoController.h
\b0 "\
	#import "
\b Kludges
\b0 .subproj/
\b MiscFindPanel.h
\b0 "  // 
\i Mind you, MFP is 
\b great
\b0  code...
\i0 \
\
//\
//	
\b Menu Validation (C code)
\b0 \
//\
	void 
\b initMenu
\b0 (Menu *
\b menu
\b0 );\
\

\i @interface eTAppUI:Object 
\i0 \{\
//\
//	
\b Instance Variables
\b0 \
//\
	Menu 			*
\b annotationMenu
\b0 ;\
	Menu 			*
\b agentMenu
\b0 ;\
	Menu 			*
\b accessoryMenu
\b0 ;\
	InfoController	*
\b infoController
\b0 ;\
	HashTable		*
\b annotationTable
\b0 ;\
	HashTable		*
\b agentTable
\b0 ;\
	Panel			*
\b toolPalette
\b0 ;\
	Matrix			*
\b toolMatrix
\b0 ;\
	\}\
	\
//\
//	
\b AppKit Delegate
\b0 \
//\
	- 
\b appWillInit
\b0 :sender;\
	- 
\b appWillTerminate
\b0 :sender;\
\
//\
//	
\b InfoController UI
\b0 \
//\
	- 
\b showInfo
\b0 :sender;\
	- 
\b showCopyright
\b0 :sender;\
	- 
\b mailDevelopers
\b0 :sender;\
\
//\
//	
\b UserModel UI
\b0 \
//\
	- 
\b showPreferences
\b0 :sender;\
\
//\
//	
\b Navigator UI
\b0 \
//\
	- 
\b showNavigator
\b0 :sender;\
\
//\
//	
\b Inspector UI
\b0 \
//\
	- 
\b showInspector
\b0 :sender;\
\
//\
//	
\b Tool Management/Registration UI
\b0 \
//\
	- 
\b loadTool
\b0 :sender;\
	- 
\b registerAnnotation
\b0 :(NXAtom) 
\b menuLabel
\b0 \
					 
\b key
\b0 :(char) 
\b key
\b0 \
					
\b name
\b0 :(NXAtom) 
\b name
\b0 \
					
\b icon
\b0 :(NXImage*) 
\b icon
\b0 ;\
	- 
\b registerAgent
\b0 :(NXAtom) 
\b menuLabel
\b0 \
				
\b key
\b0 :(char) 
\b key
\b0 \
			   
\b name
\b0 :(NXAtom) 
\b name
\b0 ;\
	- 
\b registerAccessory
\b0 :(NXAtom) 
\b menuLabel
\b0 \
					
\b key
\b0 :(char) 
\b key
\b0 \
			 	   
\b name
\b0 :(NXAtom) 
\b name
\b0 \
				 
\b target
\b0 :(id) 
\b theTarget
\b0 \
				 
\b action
\b0 :(SEL) 
\b theAction
\b0 ;\
\
//\
//	
\b Document Management UI
\b0 \
//\
	- 
\b new
\b0 :sender;		// 
\i These are the only file ops that are the app's
\i0 \
	- 
\b open
\b0 :sender;		// 
\i responsibility to implement; rest go to docUI
\i0 .\
	- 
\b openAsText
\b0 :sender;\
	- 
\b openFromPath
\b0 :(const char *)
\b path
\b0  
\b type
\b0 :(const char *)
\b aType
\b0 ;\
	- 
\b import
\b0 :sender;\
	- 
\b saveAll
\b0 :sender;\
\
//\
//	
\b Find Panel UI
\b0 \
//\
	- 
\b enterSelection
\b0 :sender;\
	- 
\b findNext
\b0 :sender;\
	- 
\b findPrevious
\b0 :sender;\
	- 
\b jumpToSelection
\b0 :sender;\
	- 
\b orderFrontFindPanel
\b0 :sender;\
\
//\
//	
\b Workspace Delegate
\b0 \
//\
	- (BOOL) 
\b appAcceptsAnotherFile
\b0 :sender;\
	- (int)
\b app
\b0 :sender 
\b openFile
\b0 :(const char *)filename 
\b type
\b0 :(const char *)aType;\
	- (int)
\b app
\b0 :sender 
\b openTempFile
\b0 :(const char *)filename 
\b type
\b0 :(const char *)aType;\
	- 
\b app
\b0 :sender 
\b powerOffIn
\b0 :(int)ms 
\b andSave
\b0 :(int)aFlag;\
\
//\
//	
\b Menu Delegate
\b0 \
//\
	- (BOOL)
\b menuItemUpdate
\b0 :(MenuCell *)
\b menuCell
\b0 ;\
	- (BOOL)
\b validateCommand
\b0 :(MenuCell *)
\b menuCell
\b0 ;\

\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx8000\fc0\cf0 	- 
\b annotationAction
\b0 :sender;		// 
\b\i PRIVATE!
\b0\i0 \
	- 
\b agentAction
\b0 :sender;				// 
\b\i PRIVATE!
\b0\i0 \

\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\fc0\cf0 \

\i @end
}
